include <structures.wdl>;

bmap bmap_lvl1_levelEnd = <lvl2_levelende.bmp>;
font font_lvl1_levelEnd, <font_lvl2_Levelende.bmp>, 21, 22;



var lvl1_tri_LevelEnd_to_x[2];
var lvl1_tri_LevelEnd_to_y[2];
var lvl1_tri_LevelEnd_to_z[2];


sound get_report_lvl1 = <getreport.wav>;
var get_report_lvl1_handle;


// Panels

// Panel levelEnd 

panel pan_lvl1_levelEnd
{
	bmap = bmap_lvl1_levelEnd;
	pos_x = -600;
	pos_y = 0;
	digits = 118,50,2, font_lvl1_levelEnd, 1, lvl1_ReportsFound;
	digits = 150,50,2, font_lvl1_levelEnd, 1, lvl1_ReportsNumber;
	flags = refresh, visible;
}



// reports

function event_Report            
{                                
	if (you == player)         // only the play can collect reports
	{
		Report_lvl1[my.skill1] = 1;
		lvl1_ReportsFound += 1;

		my.invisible = on;
		my.passable = on;
		
		get_report_lvl1_handle = snd_play(get_report_lvl1,100,0);
	}
}





define ReportNr, skill1;
define Area, skill2;
//uses: ReportNr,Area;
action lvl1_Report
{
	my.enable_impact = on;
	my.event = event_Report;
	
	while(Report_lvl1[my.ReportNr] == 0)   
	{                 
		if (activeArea[my.Area] == 0)           // if area is active
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		wait(1);
	}
}

// trigger to display the levelend

action lvl1_tri_LE_on_f // lvl1 = Level 1; tri = trigger; LE = LevelEnd; on = activate; f = from
{
	wait(2);
	trace_mode = ignore_me + ignore_passable + ignore_passents + ignore_sprites + use_box + activate_shoot;
	
	while(1)
	{
		if (vec_dist(my.x, player.x) < 200) // if player in the near
		{													 
			trace(my.x, vector(lvl1_tri_LevelEnd_to_x[0],lvl1_tri_LevelEnd_to_y[0],lvl1_tri_LevelEnd_to_z[0]));
			
		
			if (you == player)
			{
				pan_lvl1_levelEnd.pos_x = RoundValue((screen_size.x - 251) /2);
				pan_lvl1_levelEnd.pos_y = RoundValue((screen_size.y - 98) /2);			
			}
			
			if  (pausemenu_active == 1)
			{
				pan_lvl1_levelEnd.pos_x = -2000;
			}
		}
		wait(1);
	}
}


action lvl1_tri_LE_on_t // lvl1 = Level 1; tri = trigger; LE = LevelEnd; on = activate; t = to
{
	lvl1_tri_LevelEnd_to_x[0] = my.x;
	lvl1_tri_LevelEnd_to_y[0] = my.y;
	lvl1_tri_LevelEnd_to_z[0] = my.z;
}

action lvl1_tri_LE_off_f // // lvl1 = Level 1; tri = trigger; LE = LevelEnd; off = deactivate; f = from
{
	wait(2);
	trace_mode = ignore_me + ignore_passable + ignore_passents + ignore_sprites + use_box + activate_shoot;
	
	while(1)
	{
		if (vec_dist(my.x, player.x) < 200) // if player in the near
		{													 
			trace(my.x, vector(lvl1_tri_LevelEnd_to_x[1],lvl1_tri_LevelEnd_to_y[1],lvl1_tri_LevelEnd_to_z[1]));
			
		
			if (you == player)
			{
				
				pan_lvl1_levelEnd.pos_x = 2000;
				
				
			}
		}
		wait(1);
	}
}


action lvl1_tri_LE_off_t // // lvl1 = Level 1; tri = trigger; LE = LevelEnd; off = deactivate; t = to
{
	lvl1_tri_LevelEnd_to_x[1] = my.x;
	lvl1_tri_LevelEnd_to_y[1] = my.y;
	lvl1_tri_LevelEnd_to_z[1] = my.z;
}


// trigger action to load level 2
define Area, skill1;
define Triggerpair, skill2;
// uses: Triggerpair
action trigger_LoadLevel2
{
	var ZielPos[3];
	
	wait(2);
	trace_mode = ignore_me + ignore_passable + ignore_passents + ignore_sprites + use_box + activate_shoot;
	
	
	while(1)
	{
		if (vec_dist(my.x, player.x) < 200) // if player in the near
		{													 
		
			trace(my.x, vector(tri_to_x[my.Triggerpair],tri_to_y[my.Triggerpair],tri_to_z[my.Triggerpair]));
			
		
			if (you == player && lvl1_ReportsFound == lvl1_ReportsNumber)
			{
				pan_lvl1_levelEnd.pos_x = 2000;
				load_level2();
				
				
			}
			
			while (you != null && you !=player && vec_dist(my.x, player.x) < 2000)
			{
				vec_set(ZielPos, target);
				trace(target, vector(tri_to_x[my.Triggerpair],tri_to_y[my.Triggerpair],tri_to_z[my.Triggerpair]));
			
				wait(1);
				vec_set(target, ZielPos);
			}
		}

		wait(1);
	}
	
	
}

define Triggerpair, skill2; 
// uses: Triggerpair
action trigger_to_level2
{
	tri_to_x[my.Triggerpair] = my.x;
	tri_to_y[my.Triggerpair] = my.y;
	tri_to_z[my.Triggerpair] = my.z;
	wait(1);
}



// special action to combine a special object with a button

define SpecialObjectNr, skill1;
define WaitBeforeStart, skill2;
define MovetoX, skill3;
define WaitBeforeBack, skill4;
define Area, skill5;
//uses: SpecialObjectNr,WaitBeforeStart, MovetoX, WaitBeforeBack, Area;
action lvl1_sobj
{
	my.skill90 = my.x;  
	my.skill91 = my.y;
	my.skill92 = my.z;
	
	
	while(1)
	{
		if (menu_active == 0)
		{
		
		if (activeArea[my.Area] == 0)           // if area is active
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if (SpecialObject_ActivateWithNumber[my.SpecialObjectNr] == 1)
		{
			sleep(my.WaitBeforeStart);
			SpecialObject_IsMoving[my.SpecialObjectNr] = 1;
			
			
			
			if (my.skill90 > my.MoveToX)
			{
			
			while(my.x > (my.MoveToX))
			{
				if (menu_active == 0)
				{
				
				my.x -= 2 * time;
				}
				wait(1);
			}
			my.x = my.MoveToX;
			sleep(my.WaitBeforeBack);
			
			while(my.x < my.skill90)
			{
				if (menu_active == 0)
				{
					
				
				my.x += 2 * time;
			}
				wait(1);
			}
			my.x = my.skill90;
			}
			
			
			if (my.skill90 < my.MoveToX)
			{
			
			while(my.x < (my.MoveToX))
			{
				if (menu_active == 0)
				{
				
				my.x += 2 * time;
				}
				wait(1);
			}
			my.x = my.MoveToX;
			sleep(my.WaitBeforeBack);
			
			while(my.x > my.skill90)
			{
				if (menu_active == 0)
				{
				
				my.x -= 2 * time;
				}
				wait(1);
			}
			my.x = my.skill90;
			}
			
			
			
			
				specialObject_ActivateWithNumber[my.specialObjectNr] = 0;
				SpecialObject_IsMoving[my.SpecialObjectNr] = 0;
			
		}
		}
		wait(1);
	}
}


// special action to combine a special object with a button

define SpecialObjectNr, skill1;
define WaitBeforeStart, skill2;
define MovetoZ, skill3;
define WaitBeforeBack, skill4;
define Area, skill5;
//uses: SpecialObjectNr,WaitBeforeStart, MovetoZ, WaitBeforeBack, Area;
action lvl1_sobj2
{
	my.skill90 = my.x;  
	my.skill91 = my.y;
	my.skill92 = my.z;
	
	
	while(1)
	{
		if (menu_active == 0)
		{
		
		if (activeArea[my.Area] == 0)           // if area is active
		{
			my.invisible = off;
			my.passable = off;
		}
		else
		{
			my.invisible = on;
			my.passable = on;
		}
		
		if (SpecialObject_ActivateWithNumber[my.SpecialObjectNr] == 1)
		{
			sleep(my.WaitBeforeStart);
			SpecialObject_IsMoving[my.SpecialObjectNr] = 1;
			
			
			
			if (my.skill92 > my.MoveToZ)
			{
			
			while(my.z > (my.MoveToZ))
			{
				if (menu_active == 0)
				{
				
				my.z -= 2 * time;
				}
				wait(1);
			}
			my.z = my.MoveToZ;
			sleep(my.WaitBeforeBack);
			
			while(my.z < my.skill92)
			{
				if (menu_active == 0)
				{
					
				
				my.z += 2 * time;
			}
				wait(1);
			}
			my.z = my.skill92;
			}
			
			
			if (my.skill92 < my.MoveToZ)
			{
			
			while(my.z < (my.MoveToZ))
			{
				if (menu_active == 0)
				{
				
				my.z += 2 * time;
				}
				wait(1);
			}
			my.z = my.MoveToZ;
			sleep(my.WaitBeforeBack);
			
			while(my.z > my.skill92)
			{
				if (menu_active == 0)
				{
				
				my.z -= 2 * time;
				}
				wait(1);
			}
			my.z = my.skill92;
			}
			
			
			
			
				specialObject_ActivateWithNumber[my.specialObjectNr] = 0;
				SpecialObject_IsMoving[my.SpecialObjectNr] = 0;
			
		}
		}
		wait(1);
	}
}